#include<iostream>
#include<set>
#include<map>
#include<string>
#include<stdio.h>
#include<sstream>
#include<algorithm>
#include<queue>
#include<cmath>
#include<string.h>
using namespace std ;
#define INF (int)1e9
 
int N,pr[1002];
char in[1002][1002];
 
class Node {
    public:
 
    Node** children;
    bool wordEnd;
    int pri;
    int ind;
    int maxPri;
    int maxPriChild;
 
    Node() {
       children = new Node*[32];
       pri = -INF;
       ind = -1;
       maxPri = -INF;
       maxPriChild = -1;
    }
};
 
class Trie {
    public:
 
    Node* root;
 
    Trie() {
       root = new Node();
    }
 
    void insert(char word[], int pri, int ind) {
        Node *cur = root;
        for (int i = 0;word[i];i++) {
            int cd = word[i] == '-' ? 26 : word[i] - 'a';
            if (cur -> maxPri < pri) {
               cur -> maxPri = pri;
               cur -> maxPriChild = cd;
            }
            if (cur -> children[cd] == 0) {
                 cur -> children[cd] = new Node();
            }
            cur = cur -> children[cd];
        }
        cur -> wordEnd = true;
        cur -> pri = pri;
        cur -> ind = ind;
    }
 
    int query(char prefix[]) {
        Node *cur = root;
        for (int i = 0;prefix[i];i++) {
            int cd = prefix[i] == '-' ? 26 : prefix[i] - 'a';
            if (cur -> children[cd] == 0) {
                return -1;
            }
            cur = cur -> children[cd];
        }
        while (!cur -> wordEnd || cur -> pri < cur -> maxPri) {
           cur = cur -> children[cur -> maxPriChild];
        }
        return cur -> ind;
    }
};
 
 
bool isWhitespace(char ch) {
   	return ch == 0 || ch == 32 || ch == '\t' || ch == 10 || ch == 13;
}
 
char NextChar() {
   	static char buffer[4096];
	   static int  idx = 0;
	   static int  len = 0;
	   if (idx == len) {
     		 len = fread(buffer, 1, 4096, stdin);
		      idx = 0;
        if(len == 0) return 0;
   	}
   	return buffer[idx++];
}
 
bool readInt(int &n) {
   	char ch;
   	while(1) {
    		  ch = NextChar();
		      if(ch == 0) return false;
      		if(!isWhitespace(ch)) break;
   	}
	   int sign = 1;
	   if(ch == '-') sign = -1;
   	else if(ch != '+') n = ch - '0';
   	while(isdigit(ch = NextChar())) n = n * 10 + ch - '0';
	   n *= sign;
	   return true;
}
 
bool readString(char s[]) {
    int sz = 0;
 	  char ch;
   	while(1) {
    		  ch = NextChar();
		      if(ch == 0) return false;
      		if(isWhitespace(ch)) break;
        s[sz++] = ch;
   	}
    s[sz] = 0;
    return true;
}
 
int main() {
        Trie* trie = new Trie();
        
        readInt(N);
        for (int i = 0;i < N;i++) {
            readString(in[i]);
            readInt(pr[i]);
//            cout << in[i] << endl ;
//            scanf("%s%d",in[i],&pr[i]);
            trie -> insert(in[i],pr[i],i);
        }
 
        int Q;
        readInt(Q);
//        scanf("%d",&Q);
        while(Q-- > 0) {
             char prefix[1002];
             readString(prefix);
//             scanf("%s",prefix);
             int ret = trie -> query(prefix);
             if(ret == -1) printf("NO\n");
             else printf("%s\n",in[ret]);
        }
 
}
